var gTux;

function drawBoard() {
  var board = $('board');
  for (var row = 0; row < 3; ++row)
    for (var col = 0; col < 3; ++col) {
      var cell = new Element('span', {
        'class': 'cell ' + (1 == (row + col) % 2 ? 'white' : 'black') });
      board.appendChild(cell);
    }
} // drawBoard

function getTuxCell(tux) {
  var pos = tux.positionedOffset();
  return [(pos.left / 64).floor(), (pos.top / 64).floor()];
} // getTuxCell

function toggleTux() {
  if (gTux) {
    gTux.handle.style.cursor = 'default';
    gTux.destroy();
    gTux = null;
    return;
  }
  gTux = new Draggable('piece', {
    handle: 'pieceHandle',
    snap: function(x, y) {
      return [x, y].map(function(coord) {
        coord = ((coord - 4) / 64).round();
        return (coord < 0 ? 0 : (coord > 2 ? 2 : coord)) * 64 + 4;
      });
    },
    onStart: function() {
      $('board').addClassName('tuxMoving');
    },
    onEnd: function(d) {
      $('board').removeClassName('tuxMoving');
      var pos = getTuxCell(d.element);
      pos = 'ABC'.charAt(pos[1]) + (pos[0] + 1);
      $('log').appendChild(new Element('li').update('Tux to ' + pos));
    }
  });
  gTux.handle.style.cursor = '';
} // toggleTux

Event.observe(window, 'load', function() {
  $('chkDraggable').observe('click', toggleTux);
  drawBoard();
  toggleTux();
});
