#! /usr/bin/env ruby

require 'cgi'
require 'erb'
require 'webrick'
include WEBrick

template_text = File.read('index.rhtml')
template = ERB.new(template_text)

server = HTTPServer.new(:Port => 8042)
server.mount('/', HTTPServlet::FileHandler, '.')

source = 'Some basic text'

def xhtml_convert(text) # <label id="code.ipe.converter"/>
  '<p>' + text.gsub(/(?:\r|\n){2,}/, "</p>\n<p>").gsub('%%%', "<br/>\n") + '</p>'
end

server.mount_proc('/home') do |request, response|
  response['Content-Type'] = 'text/html'
  xhtmlVersion = xhtml_convert(source)
  response.body = template.result(binding)
end

server.mount_proc('/source') do |request, response|
  sleep 2 # Darn we're slow...
  response['Content-Type'] = 'text/plain'
  response.body = source
end

server.mount_proc('/update') do |request, response|
  sleep 2 # Darn we're slow...
  source = request.query['value']
  response.body = xhtml_convert(source)
end

trap('INT') { server.shutdown }

server.start
